                                Unit GrText;
                                 Interface

Uses Dos,Graph,TPCrt,ServUnit;
Const
  ESCFlag:Boolean=False;
  AppHandle:Boolean=True;
  EmptyBorder=0;
  SinglBorder=1;
  DoubleBorder=2;
  BorderChar:array [0..2,1..6] of Char=
  ((#32,#32,#32,#32,#32,#32),
   (#218,#196,#191,#179,#192,#217),
   (#201,#205,#187,#186,#200,#188));
Type Str80=String[80];
     Str6=String[6];
Procedure ClrScr;
Procedure Colors(Text,Back:Byte);
Procedure GraphWriteOn;
Procedure GraphWriteOff;
Procedure SetFont(Fnt:Pointer;x,y:Byte);
Function GetMaxLine:Byte;
Function GetMaxChar:Byte;
Procedure GotoXY(x,y:Byte);
Procedure TextBackGround(Color:Byte);
Procedure TextColor(Color:Byte);
Function WhereX:Byte;
Function WhereY:Byte;
Function GraphCooX(x:Byte):Integer;
Function GraphCooY(y:Byte):Integer;
Procedure Window(x1,y1,x2,y2:Byte);
Function TextCooX(x:Integer):Byte;
Function TextCooY(y:Integer):Byte;
Procedure OpenWindow(x1,y1,x2,y2,Border:Byte;Header:String;Shadow:Boolean);
Procedure TransparentWin(x1,y1,x2,y2:Integer;density,C:Byte);
Procedure LoadFont(NameFnt:Str80;x,y:Byte);
                             Implementation
Type
  aob=array [0..MaxInt] of Byte;
Const
  ChangeWR:Boolean=False;
  Font:^aob=Nil;
Var
  OldOut,OldInp:Text;
  Adapter:Byte;
  Xf,Yf:Byte;
  TCol,BCol:Byte;
  xg,yg:Integer;
  xt,yt:Byte;
  x1t,y1t,x2t,y2t:Byte;
  x1g,y1g,x2g,y2g:Integer;
  maxLine,maxChar:Byte;
Procedure WriteChar(x,y:Integer;Ch:Byte);
Var
  k:Integer;
  b,j:Byte;
Begin
  For k:=0 To Pred(Yf) Do
     Begin
       b:=Font^[Ch*Yf+k];
       Case Adapter of
         0:Begin
             For j:=0 To 7 Do
               If b and (128 shr j)<>0 Then
                 PutPixel(x*xf+j,y+k,TCol)
               Else If BCol<>0 Then
                 PutPixel(x*xf+j,y+k,BCol);
           End;
         1:asm
             mov ax,$A000
             mov es,ax
             mov bx,y
             add bx,k
             mov cl,4
             shl bx,cl
             mov dx,bx
             mov cl,2
             shl bx,cl
             add bx,dx
             add bx,x
             mov dx,$3CE
             mov al,5
             out dx,al
             inc dx
             mov al,2
             out dx,al
             mov dx,$3CE
             mov al,8
             out dx,al
             inc dx
             mov al,b
             out dx,al
             mov al,es:[bx]
             mov al,TCol
             mov es:[bx],al
             mov dl,BCol
             cmp dl,0
             je @0
             mov dx,$3CE
             mov al,8
             out dx,al
             inc dx
             mov al,b
             not al
             out dx,al
             mov al,es:[bx]
             mov al,BCol
             mov es:[bx],al
           @0:
           End;
       End;
     End;
End;
Function GraphRead(Var f:TextRec):Integer;Far;
Var
  x0t:Byte;
  yup,ydn:Integer;
  InsFlag:Boolean;
  Cur:Pointer;
  Back:Pointer;
  s:String;
  c:Char;
Const
  CSize:Word=0;
Procedure SetCursor;
Var
  FillInfo:FillSettingsType;
Begin
  If CSize<>0 Then
    Begin
      FreeMem(Back,CSize);
      FreeMem(Cur,CSize);
    End;
  ydn:=yg+yf-1;
  If InsFlag Then
    yup:=ydn-2
  Else
    yup:=yg;
  CSize:=ImageSize(xg,yup,xg+xf-1,ydn);
  GetMem(Back,CSize);
  GetImage(xg,yup,xg+xf-1,ydn,Back^);
  GetFillSettings(FillInfo);
  SetFillStyle(SolidFill,TCol);
  Bar(xg,yup,xg+xf-1,ydn);
  With FillInfo Do
    SetFillStyle(Pattern,Color);
  GetMem(Cur,CSize);
  GetImage(xg,yup,xg+xf-1,ydn,Cur^);
  PutImage(xg,yup,Back^,NormalPut);
End;
Procedure Cursor;
Var
  k:Integer;
Const
  d=300;
Begin
  GetImage(xg,yup,xg+xf-1,ydn,Back^);
  While not KeyPressed Do
    Begin
      PutImage(xg,yup,Cur^,NormalPut);
      For k:=1 To 10 Do
        If not KeyPressed Then
          Delay(d);
      PutImage(xg,yup,Back^,NormalPut);
      For k:=1 To 10 Do
        If not KeyPressed Then
          Delay(d);
    End;
End;
Procedure Home;
Begin
  GotoXY(X0t,WhereY)
End;
Procedure Left;
Begin
  If WhereX>x0t Then
    GotoXY(WhereX-1,WhereY);
End;
Procedure Right;
Begin
  If WhereX-x0t<Length(s) Then
    GotoXY(WhereX+1,WhereY);
End;
Procedure EndKey;
Begin
  GotoXY(x0t+Length(S),WhereY)
End;
Procedure Ins;
Begin
  InsFlag:=not InsFlag;
  SetCursor;
End;
Procedure WriteString;
Var
  k:Byte;
Begin
  For k:=1 To Length(s) Do
    WriteChar(x1t+x0t+k-3,yg,ord(s[k]));
  WriteChar(x1t+x0t+Length(s)-2,yg,32);
End;
Procedure Del;
Var
  n:Byte;
Begin
  n:=WhereX-x0t;
  If n<Length(s) Then
    Begin
      Delete(S,n+1,1);
      WriteString;
    End;
End;
Procedure BackSpace;
Var
  n:Byte;
Begin
  n:=WhereX-x0t;
  If n>0 Then
    Begin
      Delete(S,n,1);
      WriteString;
      GotoXY(WhereX-1,WhereY);
    End;
End;
Procedure AnyChar;
Var
  n:Byte;
Begin
  n:=WhereX-x0t;
  If n=Length(s) Then
    If x1t+x0t+Length(s)<=x2t Then
      s:=s+c
    Else
  Else
    If InsFlag and (x1t+x0t+Length(s)<=x2t) Then
      Insert(C,s,n+1)
    Else
      s[n+1]:=c;
  WriteString;
  GotoXY(WhereX+1,WhereY);
End;
Procedure Enter;
Var
  k:Byte;
Begin
  With f Do
    Begin
      For k:=1 To Length(S) Do
        BufPtr^[BufEnd+k-1]:=S[k];
      BufEnd:=Length(s);
      If BufEnd=0 Then
        Begin
          BufEnd:=1;
          BufPtr^[0]:=' ';
        End;
    End;
  GotoXY(1,WhereY+1);
End;
Procedure Esc;
Begin
  With f Do
    Begin
      BufEnd:=1;
      BufPtr^[0]:=' ';
      EscFlag:=True;
    End;
End;
Begin
  With f Do If (Mode=fmInput) and (BufEnd=0) Then
    Begin
      x0t:=WhereX;
      s:='';
      InsFlag:=True;
      EscFlag:=False;
      SetCursor;
      Repeat
        Cursor;
        c:=ReadKey;
        Case c of
        #0:Case ord(ReadKey) of
           71:Home;
           75:Left;
           77:Right;
           79:EndKey;
           82:Ins;
           83:Del;
           Else
             c:=#0
           End;
        #8:BackSpace;
        #13:Enter;
        #27:Esc;
        Else
          AnyChar;
        End;
      Until (c=#13) or (c=#27);
      FreeMem(Back,CSize);
      FreeMem(Cur,CSize);
      CSize:=0;
    End;
  GraphRead:=0;
End;
Function GraphWrite(Var f:TextRec):Integer; FAR;
Var
  Drv,Mode:Integer;
  k:Integer;
  Reg:Registers;
Begin
  If Font=Nil Then
    Exit;
  DetectGraph(Drv,Mode);
  If AppHandle and (Drv in [3..5,9]) Then
    Adapter:=1
  Else
    Adapter:=0;
  With f Do
    If (Mode=fmOutput) and (BufPos>0) Then
      Begin
        For k:=0 To BufPos-1 Do
          Case BufPtr^[k] of
            #7:With Reg Do
               Begin
                 ah:=$E;
                 al:=7;
                 Intr($10,Reg);
               End;
            #8:If k>BufEnd Then
               Begin
                 WriteChar(xt-2,yg,32);
                 GotoXY(WhereX-1,WhereY);
               End;
            #10:If yt+1 in [y1t..y2t] Then
                GotoXY(WhereX,WhereY+1);
            #13:GotoXY(1,WhereY);
            Else
              Begin
                WriteChar(xt-1,yg,ord(BufPtr^[k]));
                If xt+1 in [x1t..x2t] Then
                  GotoXY(WhereX+1,WhereY)
                Else If yt+1 in [y1t..y2t] Then
                  GotoXY(1,WhereY+1);
              End;
            End;
          BufPos:=0;
      End;
  GraphWrite:=0;
End;
Function Zero(Var f:TextRec):Integer;Far;
Begin
  Zero:=0;
End;
Function Flush(Var f:TextRec):Integer;Far;
Begin
  With f Do
    Begin
      BufPos:=0;
      BufEnd:=0;
    End;
  Flush:=0;
End;
Procedure ClrScr;
Var
  FillInfo:FillSettingsType;
Begin
  If Font<>Nil Then
    Begin
      GetFillSettings(FillInfo);
      SetFillStyle(SolidFill,BCol);
      Bar(x1g,y1g,x2g,y2g);
      With FillInfo Do
        SetFillStyle(Pattern,Color);
      GotoXY(1,1);
    End;
End;
Procedure Colors(Text,Back:Byte);
Begin
  TextColor(Text);
  TextBackGround(Back);
End;
Function GetMaxChar:Byte;
Begin
  GetMaxChar:=MaxChar;
End;
Function GetMaxLine:Byte;
Begin
  GetMaxLine:=MaxLine;
End;
Function GraphCooX(x:Byte):Integer;
Begin
  If Font<>Nil Then
    GraphCooX:=pred(x)*xf
  Else GraphCooX:=-1;
End;
Function GraphCooY(y:Byte):Integer;
Begin
  If Font<>Nil Then
    GraphCooY:=pred(y)*yf
  Else GraphCooY:=-1;
End;
Procedure GotoXY(x,y:Byte);
Begin
  If (Font<>Nil) and  (x in [1..MaxChar]) and
     (y in [1..MaxLine]) and (x<=x2t-x1t+1) and (y<=y2t-y1t+1) Then
    Begin
      xt:=x+x1t-1;
      yt:=y+y1t-1;
      xg:=GraphCooX(xt);
      yg:=GraphCooY(yt);
    End;
End;
Procedure GraphWriteOn;
Begin
  If not ChangeWR Then
    Begin
      Move(Output,OldOut,SizeOf(Output));
      With TextRec(Output) Do
        Begin
          OpenFunc:=@Zero;
          CloseFunc:=@Zero;
          FlushFunc:=@GraphWrite;
          InOutFunc:=@GraphWrite;
        End;
      Move(Input,OldInp,SizeOf(Input));
      With TextRec(Input) Do
        Begin
          OpenFunc:=@Zero;
          CloseFunc:=@Zero;
          FlushFunc:=@Flush;
          InOutFunc:=@GraphRead;
        End;
      ChangeWR:=True;
    End;
End;
Procedure GraphWriteOff;
Begin
  If ChangeWR Then
    Begin
      Move(OldOut,Output,SizeOf(Output));
      Move(OldInp,Input,SizeOf(Input));
      ChangeWR:=False;
    End;
End;
Procedure SetFont(Fnt:Pointer;x,y:Byte);
Begin
  Font:=Fnt;
  MaxChar:=succ(GetMaxX) div x;
  MaxLine:=succ(GetMaxY) div y;
  xf:=x;
  yf:=y;
  Window(1,1,MaxChar,MaxLine);
End;
Function WhereX:Byte;
Begin
  If Font<>Nil Then
    WhereX:=xt-x1t+1
  Else WhereX:=0;
End;
Function WhereY:Byte;
Begin
  If Font<>Nil Then
    WhereY:=yt-y1t+1
  Else WhereY:=0;
End;
Procedure Window(x1,y1,x2,y2:Byte);
Begin
  If (Font<>Nil) and (x1 in [1..MaxChar]) and
     (y1 in [1..MaxLine]) and (x2 in [1..MaxChar]) and
     (y2 in [1..MaxLine]) and (x2>=x1) and (y2>=y1) Then
    Begin
      xt:=x1;
      yt:=y1;
      xg:=xf*pred(xt);
      yg:=yf*pred(yt);
      x1t:=x1;
      y1t:=y1;
      x2t:=x2;
      y2t:=y2;
      x1g:=xf*pred(x1t);
      y1g:=yf*pred(y1t);
      x2g:=xf*x2t;
      y2g:=yf*y2t;
    End;
End;
Procedure TextBackGround(Color:Byte);
Begin
  BCol:=Color;
End;
Procedure TextColor(Color:Byte);
Begin
  TCol:=Color;
End;
Function TextCooX(x:Integer):Byte;
Begin
  If (Font<>Nil) and (x in [0..GetMaxX]) Then
    TextCooX:=round(x/MaxChar)+1
  Else
    TextCooX:=0;
End;
Function TextCooY(y:Integer):Byte;
Begin
  If (Font<>Nil) and (y in [0..GetMaxY]) Then
    TextCooY:=round(y/MaxLine)+1
  Else
    TextCooY:=0;
End;
Procedure OpenWindow;
Procedure WinFrame(dx,dy:Byte;Symbols:Str6);
Var i:Byte;
Begin
  Write(Symbols[1]);
  For i:= 1 To dx-2  Do Write(Symbols[2]);
  Write(Symbols[3]);
  For i:=1 To dy-2 Do begin
    Gotoxy(1,i+1);Write(Symbols[4]);
    Gotoxy(dx,i+1);Write(Symbols[4]);
  End;
  Write(Symbols[5]);
  For i:=1 to dx-2 Do Write(Symbols[2]);
  Write(Symbols[6]);
End;
Var i,j:Byte;
Begin
  Window(x1,y1,x2,y2);
  TextColor(TCol);
  TextBackGround(BCol);
  ClrScr;
  Window(x1,y1,x2,y2+1);
  If Border=3 Then
    Begin
      SetFillStyle(1,BCol);
      Bar(x1g,y1g,x2g-1,y2g-16);
      SetLineStyle(0,0,3);
      SetColor(8);
      Line(x2g-1,y1g,x2g-1,y2g-16);
      Line(x1g+1,y1g,x1g+1,y2g-16);
      Line(x1g,y2g-1-16,x2g,y2g-1-16);
      SetLineStyle(0,0,0);
      SetColor(7);
      Line(x2g-3,y1g,x2g-3,y2g-16);
      Line(x1g+3,y1g,x1g+3,y2g-16);
      Line(x1g+3,y1g+9,x2g-3,y1g+9);
      Line(x1g,y2g-3-16,x2g,y2g-3-16);
      SetFillStyle(1,8);
      Bar(x1g,y1g,x2g,y1g+8);
    End
  Else
    If Border=4 Then
      Begin
        SetFillStyle(1,BCol);
        Bar(x1g,y1g,x2g-1,y2g-16);
        SetLineStyle(0,0,3);
        SetColor(8);
        Line(x2g-1,y1g,x2g-1,y2g-16);
        Line(x1g+1,y1g,x1g+1,y2g-16);
        Line(x1g,y2g-1-16,x2g,y2g-1-16);
        SetFillStyle(1,8);
        Bar(x1g,y1g,x2g,y1g+8);
        SetColor(7);
        SetLineStyle(0,0,1);
        Line(x2g-3,y1g+9,x2g-3,y2g-30-16);
        Line(x2g-3,y2g-30-16,x2g-6,y2g-27-16);
        Line(x2g-6,y2g-27-16,x2g-6,y2g-6-16);
        Line(x1g+3,y2g-3-16,x2g-30,y2g-3-16);
        Line(x2g-30,y2g-3-16,x2g-27,y2g-6-16);
        Line(x2g-27,y2g-6-16,x2g-6,y2g-6-16);
      End;
  If (Header>'') and (Border>2) Then
    Begin
      SetColor(15);
      OutTextXY((x2g-x1g-Length(Header)*8) div 2+x1g,y1g,Header);
    End;
  SetColor(TCol);
  If Border<3 Then
    Begin
      WinFrame(x2-x1+1,y2-y1+1,BorderChar[Border]);
      If Header>'' Then
        Begin
          Window((x2-x1-Length(Header)) div 2+1,y1,(x2-x1-Length(Header)) div 2+2+Length(Header),y1);
          ClrScr;
          If Length(header)>x2-x1-4 Then
            Header[0]:=chr(x2-x1-4);
          Write(' ',Header,' ');
        End;
    End;
  Window(x1+1,y1+1,x2-1,y2-1);
  If Shadow Then
    Begin
      SetFillStyle(SolidFill,0);
      Bar(x2g+9,y1g,x2g+17,y2g+16);
      Bar(x1g+8,y2g+17,x2g+17,y2g+26);
    End;
End;
Procedure TransparentWin(x1,y1,x2,y2:Integer;density,C:Byte);
Var i,j:Integer;
Begin
  For i:=x1 To x2 Do
    For j:=y1 To y2 Do
       If (i mod (density+1)=0) and (j mod (density+1)=0) Then PutPixel(i,j,c)
End;
Procedure LoadFont(NameFnt:Str80;x,y:Byte);
Var
  f:File;
  p:Pointer;
Begin
  If FileExist(NameFnt) Then
    Begin
      Assign(f,NameFnt);
      Reset(f,1);
      GetMem(p,FileSize(f));
      BlockRead(f,p^,FileSize(f));
      Close(f);
      SetFont(p,x,y);
    End
  Else
    Begin
      CloseGraph;
      WriteLn(' ',NameFnt,'  ');
      Halt(1);
    End;
End;
End.