                                Unit WinUnit;
                                  InterFace
Uses DataUnit;
Type
  Screen= array [1..25,1..80] of Record
                                   Ch:Char;
                                   At:Byte;
                                 End;
Var scr:Screen absolute $B800:$0000;
    keyID:set of Char;
    OldScreen:Screen;
Procedure FullRectangle(x,y,x1,y1:Byte;Ch:Char);
Function InputNumber(x0,y0,BGround,TextCol,Pos:Byte;min,max:Integer;Var Number:Integer):Char;
Procedure ReadIntNumber(x0,y0,dx,ColorText,ColorGround:Byte;Min,Max:Integer;Var Number:Integer);
Procedure OpenWindow(x1,y1,x2,y2,ColorText,ColorGround:Byte;Frame:Byte;Shadow:Boolean);
Procedure Morph(xf1,yf1,xf2,yf2,xt1,yt1,xt2,yt2,Txt,Col:Byte);
Procedure Grid_for_Matrix(x1,y1,cg,ct,n,m,{⮫,ப}dx:Byte;Symb:Str11);
Procedure Message(Line,ColorTextContr,ColorText,ColorGround:Byte;TextMessage:Str90;Center:Boolean);
Procedure SaveScr(Var Scrin:Screen);
Procedure LoadScr(Scrin:Screen);
Function Question(Title,Mes1,Mes2:Str80):Boolean;
Procedure Button(x0,y0,ColorText,ColorGround,ColorKey:Byte;Txt:Str11);
Procedure ShowButton(X,Y,Width:Byte;Text:String;Active:Boolean);
Procedure ColorWindow(x1,y1,x2,y2,Color:Byte);
Procedure ShowTimer;
                               Implementation
Uses TpCrt;
Const
   BorderChar:array [0..2,1..6] of Char=
  ((#32,#32,#32,#32,#32,#32),
   (#218,#196,#191,#179,#192,#217),
   (#201,#205,#187,#186,#200,#188));
   Speed=3;
Var
  tmp:Screen;
Procedure SaveScr(Var Scrin:Screen);
Begin
  Scrin:=Scr;
End;
Procedure LoadScr(Scrin:Screen);
Begin
  Scr:=Scrin;
End;
Procedure OpenWindow;
Procedure WinFrame(dx,dy:Byte;Symbols:Str6);
Var i:Byte;
Begin
  Write(Symbols[1]);
  For i:= 1 To dx-2  Do Write(Symbols[2]);
  Write(Symbols[3]);
  For i:=1 To dy-2 Do begin
    Gotoxy(1,i+1);Write(Symbols[4]);
    Gotoxy(dx,i+1);Write(Symbols[4]);
  End;
  Write(Symbols[5]);
  For i:=1 to dx-2 Do Write(Symbols[2]);
  Write(Symbols[6]);
End;
Const
   BorderChar:array [0..2,1..6] of Char=
  ((#32,#32,#32,#32,#32,#32),
   (#218,#196,#191,#179,#192,#217),
   (#201,#205,#187,#186,#200,#188));
Var i,j:Byte;
Begin
  If Shadow Then
    Begin
      Tmp:=Scr;
      If x2<79 Then
      For i:=1 To 2 Do{c}
        For j:=y1+1 To y2+1 Do
          Tmp[j,x2+i].at:=$08;
      For i:=x1+2 To x2+1 Do{᭨}
      Tmp[y2+1,i].at:=$08;
      Scr:=Tmp;
    End;
  Window(x1,y1,x2,y2);
  TextColor(ColorText);
  TextBackGround(ColorGround);
  ClrScr;
  Window(x1,y1,x2,y2+1);
  WinFrame(x2-x1+1,y2-y1+1,BorderChar[frame]);
  Window(x1+1,y1+1,x2-1,y2-1);
End;
Procedure Morph(xf1,yf1,xf2,yf2,xt1,yt1,xt2,yt2,Txt,Col:Byte);
Var wind:Screen;
    Ch:String;
Begin
  SaveScr(wind);
  Ch:=Wind[yf1,xf1].Ch;
  Ch:=Ch+Wind[yf1,xf1+1].Ch;
  TextColor(txt);
  TextBackGround(Col);
  Window(xf1,yf1,xf2,yf2-1);
  ClrScr;
  SaveScr(wind);
Repeat
  If xf1>xt1 Then dec(xf1,((xf1-xt1)Shr speed)+1);
  If xf1<xt1 Then inc(xf1,((xt1-xf1)Shr speed)+1);
  If yf1>yt1 Then dec(yf1,((yf1-yt1)Shr speed)+1);
  If yf1<yt1 Then inc(yf1,((yt1-yf1)Shr speed)+1);
  If xf2>xt2 Then dec(xf2,((xf2-xt2)Shr speed)+1);
  If xf2<xt2 Then inc(xf2,((xt2-xf2)Shr speed)+1);
  If yf2>yt2 Then dec(yf2,((yf2-yt2)Shr speed)+1);
  If yf2<yt2 Then inc(yf2,((yt2-yf2)Shr speed)+1);
  Window(xf1,yf1+1,xf2,yf2);
  ClrScr;
  Write(ch);
  Delay(1000);
  LoadScr(Wind);
Until (xf1=xt1)And(xf2=xt2)And(yf1=yt1)And(yf2=yt2);
End;

Function InputNumber(x0,y0,BGround,TextCol,Pos:Byte;min,max:Integer;Var Number:Integer):Char;
Var Ch:Char;
    MyMessage:String[80];
    StrMin,StrMax,S:String[6];
    tmp,Code:Integer;
    i:Byte;
Begin
  NormalCursor;
  Str(min,StrMin);Str(max,StrMax);
  MyMessage:='  祭  ~'+StrMin+'  ~'+StrMax+'   ~F1    室  ~ESC ';
  Repeat
    Message(25,Red,0,15,MyMessage,False);
    NormalCursor;
    TextColor(TextCol);
    TextBackGround(BGround);
    Window(x0,y0,x0+Pos,y0);
    ClrScr;
    i:=0;
    s:='';
    Repeat
      Ch:=ReadKey;
      If (i>0) and (Ch=Bs) Then
        Begin
          Delete(S,i,1);
          dec(i);
          GotoXY(Length(s)+1,1);
          Write(' ');
          GotoXY(Length(s)+1,1);
        End;
      If (Ch in Digits) and (i<pos) Then
        Begin
          inc(i);
          s:=s+ch;
          Write(Ch);
        End
      Else
        If (i=pos) and not (Ch in KeyID) Then
          Begin
            i:=0;
            s:='';
            Window(x0,y0,x0+Pos,y0);
            ClrScr;
          End;
      If Ch=#0 Then Ch:=ReadKey;
    Until (Ch in KeyID) or (Ch=Enter);
    If i=0 Then Str(min,s);
    Val(S,tmp,Code);
    If Code<>0 Then
      Begin
        Message(25,White,White,Red,'ᮮ⢥⢨ ⨯',True);
        Readkey;
      End
    Else
      Begin
        Number:=tmp;
        If (Tmp<Min) or (Tmp>Max) Then
         Begin
           Sound(440);
           Delay(1000);
           NoSound;
           Message (25,White,White,Red,'襭  祭',True);
           ReadKey;
         End
      End;
  Until (Tmp>=Min) And (Tmp<=Max);
  InputNumber:=Ch;
End;

Procedure ReadIntNumber (x0,y0, {न }
                         dx,    {ਭ  }
                         ColorText,ColorGround:Byte;{梥}
                         Min,Max : Integer; { 祭 Number}
                         Var Number : Integer);   { ᫮}
Var
    StrMin,StrMax : Str6;
    Ior:Integer;
    Temp:LongInt;
    MyMess:Str90;
Begin
  Str(min,StrMin);Str(max,StrMax);
  MyMess:='  祭  ~'+StrMin+'  ~'+StrMax;
  Repeat
    Message (25,Red,0,15,MyMess,True);
    NormalCursor;
    OpenWindow (x0,y0,x0+dx,y0,ColorText,ColorGround,2,False);
    {$I-} Readln(Temp) ; {$I+}
    Ior:=IOResult;
    If Ior=0 Then
      If (Temp<Min) or (Temp>Max) Then Begin
        Sound(440);
        Delay(1000);
        NoSound;
        Message (25,White,White,Red,'襭  祭',True);
        ReadKey;
      End
     Else
    Else Begin
      Sound(440);
      Delay(1000);
      NoSound;
      Message(25,White,White,Red,'ᮮ⢥⢨ ⨯',True);
      Readkey;
    End;
  Until (Ior=0) And (Temp>=Min) And (Temp<=Max);
  Number:=Temp ;
  Write (Number);
End;{ReadIntNumber}

{===========================MATRIX=======================================}
Procedure Grid_for_Matrix(x1,y1,
                          cg,ct,
                          n,m,   {⮫,ப}
                          dx:Byte;
                          symb:Str11);
Var dw,i,j,dy:Byte;
{_________________________________________________________________________}
Procedure Fragment(dx:Byte;ch1,ch2:Char);
Var i:Byte;
Begin
  For i:=1 To dx Do Write(ch1);
  Write(ch2);
end;{end fragment}
{_________________________________________________________________________}
Begin
  dw:=(dx+1)*m;
  dy:=2*n;
  OpenWindow(x1,y1,x1+dw,y1+dy,cg,ct,0,False);
  Window(x1,y1,x1+dw,y1+dy+1);
  Write(symb[1]);
  For i:=1 To m Do Fragment(dx,symb[2],symb[3]);
  Gotoxy(dw+1,1);Write(symb[4]);
  For i:=1 To n-1 Do Begin
    Write(symb[5]);
    For j:=1 To m Do Fragment(dx,' ',symb[5]);
    Write(symb[6]);
    For j:=1 To m-1 Do Fragment(dx,symb[2],symb[7]);
    Fragment(dx,symb[2],symb[8]);
  End;{end for i}
  Write(symb[5]);
  For i:=1 To m Do Fragment(dx,' ',symb[5]);Write(symb[9]);
  For i:=1 To m Do Fragment(dx,symb[2],symb[10]);
  Gotoxy(dw+1,dy+1);Write(symb[11]);
End;{MATRIX}
Procedure FullRectangle(x,y,x1,y1:Byte;
                        Ch:Char);
Var
  i:Integer;
Begin
   Window(x,y,x1,y1);
   For i:=1 To (x1-x+1)*(y1-y+1) Do Begin
     Delay(4);Write(Ch);
   End;
End;
Procedure Message;
Var Count,x,i,len:Byte;
Begin
  HiddenCursor;
  OpenWindow(1,line,80,line,ColorTextContr,ColorGround,0,False);
  Count:=0; Len:=Length(TextMessage);
  For i:=1 To len Do
    If TextMessage[i]='~' Then inc(Count);
  If Center  Then x:=(80-(len-Count)) Div 2
  Else x:=2; Gotoxy(x,1);
  For i:=1 To len Do
    If TextMessage[i]='~' Then  TextColor(ColorTextContr)
    Else If TextMessage[i]=' ' Then
           Begin
             TextColor(ColorText);Write(' ');
           End
         Else Write(TextMessage[i]);
End;
Procedure ColorWindow(x1,y1,x2,y2,Color:Byte);
Begin
  TextBackGround(Color);
  Window(x1,y1,x2,y2);
  ClrScr;
End;
Procedure ShowButton(X,Y,Width:Byte;Text:String;Active:Boolean);
Var i:Byte;
    BG:Byte;
begin
  TextColor(Black);
  BG:=scr[Y+1,X].At div 16;
  for i:=1 to Width+1 do
    with scr[Y+1,X+i] do begin
      Ch:=#223;
      At:=16*BG;
    end;
  scr[Y,X+Width+1].Ch:=#220;
  scr[Y,X+Width+1].At:=16*BG;
  ColorWindow(X,Y,X+Width,Y,Green);
  if Active then TextColor(White) else TextColor(Black);
  GotoXY((Width - Length(Text)) div 2+2,1);
  Write(Text);
  TextColor(Yellow);
  GotoXY((Width - Length(Text)) div 2+2,1);
  Write(Text[1]);
end;
Procedure Button(x0,y0,ColorText,ColorGround,ColorKey:Byte;
                 Txt:Str11);
Var i,len:Byte;
Begin
  len:=Length(Txt);
  OpenWindow(x0,y0,x0+len,y0,ColorText,ColorGround,0,False);
  For i:=1 to len Do
    If Txt[i]='~' Then TextColor(ColorKey)
    Else Begin
      Write (Txt[i]);
      TextColor(ColorText);
    End;
End;
Function Question(Title,Mes1,Mes2:Str80):Boolean;
Const Yes=['','','L','l'];
      No=['','','Y','y'];
Var
  Key:Char;
  Ex:Boolean;
Begin
  HiddenCursor;
  OpenWindow(15,10,65,15,White,7,2,True);
  GotoXY((50-Length(title)) div 2,2);
  Write(Title);
  Ex:=False;
  Button(30,14,White,Green,Yellow,' ~ ');
  Button(45,14,Black,Green,Yellow,' ~ ');
  Repeat
    Key:=ReadKey;
    If Key=#0 Then Begin
      Key:=ReadKey;
      Case Key Of
        #75 : If Ex=True Then Begin
                Button(30,14,White,Green,Yellow,' ~ ');
                Button(45,14,Black,7,Yellow,' ~ ');
                Message(25,0,0,7,Mes1,True);
                Ex:=Not Ex;
              End;
        #77 : If Ex=False Then Begin
                Button(30,14,Black,7,Yellow,' ~ ');
                Button(45,14,White,Green,Yellow,' ~ ');
                Message(25,0,0,7,Mes2,True);
                Ex:=Not Ex;
              End;
      End;
    End
    Else
      If Key in Yes Then Ex:=False
      Else If Key in No+[Esc] Then Ex:=True;
  Until Key in Yes+No+[Enter,Esc];
  Question:=ex;
End;
Procedure Timer;
Var H,M,S,MS : Word;
    i        : Byte;
    Winx:Boolean;
Begin
  Winx:=False;
  HiddenCursor;
  {GetTime(H,M,S,MS);}
  i:=Wherex;
  TextColor(White);
  TextBackGround(Blue);
  Window(70,2,78,2);
  If H<10 Then Write('0');
  Write(H,':');
  gotoxy(4,1);
  If M<10 Then Write('0');
  Write(M,':');
  gotoxy(7,1);
  If S<10 Then Write('0');
  Write(S);
End;
Procedure ShowTimer;
Begin
  Repeat
    Timer;
  Until KeyPressed;
End;
Begin
  SaveScr(OldScreen);
End.