PROCEDURE VerticalRetrace;
BEGIN
     ASM
        mov dx,$3da
@1:     in al,dx
        test al,8
        jz @1
@2:     in al,dx
        test al,8
        jnz @2
     END;
END;
Procedure Analiz(x,y:Integer;Color,t,s:Byte);
Var i,j:Integer;
Begin
  SetColor(3);
  Rectangle(x-3,y-3,x+103,y+23);
  SetColor(1);
  Rectangle(x-2,y-2,x+102,y+22);
  SetColor(Color);
  j:=Round(100*t/(s+1));
  Line(x+j,y+1,x+j,y+19);
  Rectangle(x+j,y+2,x+Random(9),y+Random(20));
  VerticalRetrace;
  SetColor(0);
  Line(x+j-1,y+1,x+j-1,y+19);
End;
Procedure Init;
Var d,r:Integer;
Begin
  d:=Detect;
  InitGraph(d,r,'');
  If not(GraphResult=grOK) Then
    Begin
      WriteLn(' 樠஢ ᪨ ०');
      Halt(1);
    End;
  LoadFont('myfont.fnt',8,16);
  GraphWriteOn;
  s:='';
  Analiz(520,50,3,0,1);
  TextColor(15);
  Window(1,1,80,25);
  GotoXY(68,2);
  Write('ண');
End;
Procedure Tab(n:Byte;x,y:Integer);
Var i,j:Integer;
    c:Byte;
Begin
  For i:=1  To  n*25 Do
    Begin
      PutPixel(x,y+i,2);
      PutPixel(x-2,y+i,10);
      PutPixel(x+i-1,y,2);
      PutPixel(x+i-1,y-2,10);
      {}
      PutPixel(n*25+x,n*25-i+y,2);
      PutPixel(n*25-2+x,n*25-i+y,10);
      PutPixel(n*25-i+x,n*25+y,2);
      PutPixel(n*25-i+x,n*25-2+y,10);
      Delay(100);
    End;
  For i:=1 To n*25-2 Do
    For j:=1 To n Do
      Begin
        PutPixel(x+j*25,y+i,2);
        PutPixel(x+i,y+j*25,2);
        Delay(10);
      End;
  For c:=1 To 3 Do
    Begin
      If c=1 Then SetColor(10)
      Else If c=2 Then SetColor(15)
      Else SetColor(0);
      For i:=0 To n-1 Do
        For j:=0 To n-1 Do
          Begin
            Rectangle(x+i*25+2,y+j*25+1,x+22+i*25,y+22+j*25);
            Delay(5);
          End;
      Delay(630);
    End;
End;
Procedure Zoom;
Var i:Integer;
Begin
  For i:=1 To 230 Do
    Begin
      SetColor(2);
      Rectangle(0,1+i,640,2+i);
      Rectangle(0,460-i,640,461-i);
      VerticalRetrace;
      SetColor(0);
      Rectangle(0,1+i,640,2+i);
      Rectangle(0,460-i,640,461-i);
    End;
End;
Procedure Kub;
Var i:Integer;
Begin
  SetColor(2);
  Line(10,460,630,460);
  For i:=1 To 280 Do
    Begin
      SetColor(2);
      Line(310-i,200-trunc(i*0.6),330+i,200-trunc(i*0.6));
      Line(310-i,200-trunc(i*0.6),30,460);
      Line(330+i,200-trunc(i*0.6),610,460);
      VerticalRetrace;
      SetColor(0);
      Line(310-i,200-trunc(i*0.6),330+i,200-trunc(i*0.6));
      Line(310-i,200-trunc(i*0.6),30,460);
      Line(330+i,200-trunc(i*0.6),610,460);
    End;
  SetColor(2);
  Line(310-i,200-trunc(i*0.6),330+i,200-trunc(i*0.6));
  Line(310-i,200-trunc(i*0.6),30,460);
  Line(330+i,200-trunc(i*0.6),610,460);
End;
Procedure Message(Line,ColorTextContr,ColorText,ColorGround:Byte;TextMessage:Str90;Center:Boolean);
Var Count,x,i,len:Byte;
Begin
  HiddenCursor;
  OpenWindow(1,line,80,line,ColorTextContr,'',False);
  Count:=0; Len:=Length(TextMessage);
  For i:=1 To len Do
    If TextMessage[i]='~' Then inc(Count);
  If Center  Then x:=(80-(len-Count)) Div 2
  Else x:=2; Gotoxy(x,1);
  For i:=1 To len Do
    If TextMessage[i]='~' Then  TextColor(ColorTextContr)
    Else If TextMessage[i]=' ' Then
           Begin
             TextColor(ColorText);Write(' ');
           End
         Else Write(TextMessage[i]);
End;
Procedure Fuzz(x,y,x1,y1:Integer);
Var i,j:Word;
Begin
  Randomize;
  For j:=1 To 30 Do
    For i:=1 To (x1-x)*(y1-y)*500 Do
      PutPixel(Random(x1-x)+x,Random(y1-y)+y,0);
End;
Procedure Attention(x,y:Integer);
Var BitMap:Pointer;
    size:Byte;
    i:Byte;
    j:Integer;
Begin
  Repeat
    SetColor(14);
    OutTextXY(x,y,'!');
    size:=ImageSize(x,y-1,x+7,y+16);
    GetMem(BitMap,Size);
    GetImage(x,y-1,x+7,y+16,BitMap^);
    i:=1;
    j:=1;
    Repeat
      i:=i+j;
      If i>10 Then j:=-1;
      If i=1 Then j:=1;
      PutImage(x,y+i-5-1, BitMap^, NormalPut);
      VerticalRetrace;
  {    PutImage(x,y+i-5, BitMap^, XORPut);}
    Until KeyPressed;
    FreeMem(BitMap,Size);
  Until KeyPressed;
End;
Procedure Attention2(x,y:Integer);
Var i:Byte;
Begin
  Repeat
    For i:=1 To 3 Do
      Begin
        SetColor(2);
        OutTextXY(x+i*6,y,'>');
        VerticalRetrace;
        Delay(100);
        SetColor(10);
        OutTextXY(x+i*7,y,'>');
        VerticalRetrace;
      End;
    Verticalretrace;
    For i:=1 To 3 Do
      Begin
        SetColor(0);
        OutTextXY(x+i*7,y,'>');
        VerticalRetrace;
        VerticalRetrace;
        VerticalRetrace;
      End;
  Until KeyPressed;
End;
Procedure WriteGr(S:String;x,y,Del:Integer);
Var i:Byte;
Begin
  For i:=1 To Length(s) Do
   Begin
     SetColor(15);
     OutTextXY(x+i*8,y,'');
     Delay(del);
     SetColor(10);
     OutTextXY(x+i*8,y,'');
     Delay(del*3);
     SetColor(2);
     OutTextXY(x+i*8,y,'');
     Delay(del*5);
     SetColor(0);
     OutTextXY(x+i*8,y,'');
     SetColor(15);
     OutTextXY(x+i*8,y,s[i]);
     Delay(del*2);
     VerticalRetrace;
     SetColor(2);
     OutTextXY(x+i*8,y,s[i]);
   End;
End;
Procedure Wave(x,y,x1:Integer);
Var BitMap:Pointer;
    size:Byte;
    i,k:Byte;
    j,c:Integer;
Begin
  size:=ImageSize(x,y-1,x+8,y+16);
  GetMem(BitMap,Size);
  c:=1;
  Repeat
    GetImage(x+c*8,y-1,x+c*8+7,y+16,BitMap^);
    i:=1;
    j:=1;
    For k:=1 To 10 Do Begin
      i:=i+j;
      If i>10 Then j:=-1;
      If i=1 Then j:=1;
      PutImage(x+c*8,y+i-5-1, BitMap^, NormalPut);
      VerticalRetrace;
{      PutImage(x+c*8,y+i-5, BitMap^, XORPut);}
    End;
    PutImage(x+c*8,y-1, BitMap^, NormalPut);
    If c>((x1-x) div 7) Then c:=0;
    c:=c+1;
  Until KeyPressed;
  FreeMem(BitMap,Size);
End;
Procedure LineStr(s:String;x,y:Integer);
Var i:Integer;
Begin
  Randomize;
  For i:=1 To Length(s)*7 Do
    Begin
      SetColor(2);
      Line(x,y,x+i+Random(10),y);
      Line(x,y+7,x+i+Random(20),y+7);
      SetColor(10);
      Line(x+Length(S)*7,y+5,x+Length(s)*7-i-Random(10),y+5);
      Line(x+Length(S)*7+Random(3),y+2,x+Length(s)*7-i-Random(5),y+2);
      Delay(50);
      SetColor(0);
      Line(x,y+i div Length(s),x+i+Random(10),y+i div Length(s));
      Line(x,y+7-i div Length(s),x+i+Random(20),y+7-i div Length(s));
    End;
  OutTextXY(x,y,s);
  SetFillStyle(0,0);
  Bar(x-15,y-3,x+Length(s)*8+15,y+16);
  SetColor(2);
  OutTextXY(x,y,s);
  VerticalRetrace;
  SetColor(10);
  Delay(4000);
  OutTextXY(x,y,s);
  SetColor(15);
  VerticalRetrace;
  Delay(2000);
  OutTextXY(x,y,s);
End;
Procedure FlyMenu2(Width,Hight,y:Integer;Color:Byte;Var Index:Byte);
Var n:Byte;
Procedure Cursor;
Var i:Byte;
Begin
  While not KeyPressed Do
    Begin
      i:=0;
      While (i<80) and not KeyPressed Do
        Begin
          PutPixel(647-Width+i,y+20+n*35,10);
          VerticalRetrace;
          inc(i);
        End;
       i:=0;
       While (i<80) and not KeyPressed Do
        Begin
          PutPixel(647-Width+i,y+20+n*35,0);
          VerticalRetrace;
          inc(i);
        End;
    End;
   SetColor(0);
   Line(647-Width,y+20+n*35,630,y+20+n*35);
End;
Var i:Integer;
    Ch:Char;
    Ex:Boolean;
Begin
  For i:=1 To Width Do
    Begin
      SetColor(Color);
      Rectangle(635-i,y,635,y+17);
      Rectangle(635-i+2,y+2,635-2,y+17-2);
      SetColor(0);
      VerticalRetrace;
      Rectangle(635-i,y,635+1,y+17);
      Line(634,y+1,634,y+16);
    End;
  For i:=17 To Hight+17 Do
    Begin
      SetColor(Color);
      Rectangle(635-Width,y,635,y+i);
      OutTextXY(635-Width+5,y+i+3,'');
      SetColor(0);
      VerticalRetrace;
      Rectangle(635-Width,y,635,y+i);
      OutTextXY(635-Width+5,y+i+3,'');
    End;
  SetColor(Color);
  Rectangle(635-Width,y,635,y+i);
  OutTextXY(635-Width+5,y+i+3,'');
  For i:=1 To 5 Do
    WriteGr(menu[i],635-Width+5,y+10+i*35,100);
  n:=1;
  Ex:=False;
  Repeat
    Cursor;
    Ch:=Readkey;
    Case Ch of
      #0:Begin
           Ch:=ReadKey;
           Case Ch of
             Up:If n>1 Then dec(n);
             Dn:If n<5 Then inc(n);
           End;
         End;
    Else If Ch=Enter Then
      Begin
        Index:=n;
        Ex:=True;
      End;
    End;
  Until (Ch=Esc) or Ex;
  If Ch=Esc Then Index:=0;
  SetFillStyle(0,0);
  Bar(635-Width,y,635,y+Hight+30);
End;
Procedure SaveWindow(x1,y1,x2,y2:Integer;Var Pic:Pointer;Var size:Word);
Begin
  size:=ImageSize(x1,y1,x2,y2);
  GetMem(Pic,Size);
  GetImage(x1,y1,x2,y2,Pic^);
End;
Procedure LoadWindow(x,y,size:Word;Var Pic:Pointer);
Begin
  VerticalRetrace;
  PutImage(x,y,Pic^,NormalPut);
  FreeMem(Pic,Size);
  Pic:=Nil;
End;
